=== modified file 'NEWS'
--- NEWS	2008-03-10 17:13:08 +0000
+++ NEWS	2008-03-11 22:15:16 +0000
@@ -54,6 +54,9 @@
     * Disable plink's interactive prompt for password.
       (#107593, Dmitry Vasiliev)
 
+    * Don't ask a password if there is no real terminal.
+      (Alexander Belchenko, #69851)
+
     * Include quick-start-summary.svg file to python-based installer(s)
       for Windows. (#192924, Alexander Belchenko)
 

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2008-02-24 17:19:56 +0000
+++ bzrlib/errors.py	2008-03-11 22:15:16 +0000
@@ -2576,3 +2576,8 @@
 
     def __init__(self, timezone):
         self.timezone = timezone
+
+
+class NotATerminal(BzrError):
+
+    _fmt = 'Unable to ask password without real terminal.'

=== modified file 'bzrlib/ui/__init__.py'
--- bzrlib/ui/__init__.py	2007-08-15 04:33:34 +0000
+++ bzrlib/ui/__init__.py	2008-03-11 22:15:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-
-
 """UI abstraction.
 
 This tells the library how to display things to the user.  Through this
@@ -35,6 +33,7 @@
 import getpass
 
 from bzrlib import (
+    errors,
     osutils,
     progress,
     trace,
@@ -125,6 +124,8 @@
                 return False
 
     def get_non_echoed_password(self, prompt):
+        if not sys.stdin.isatty():
+            raise errors.NotATerminal()
         encoding = osutils.get_terminal_encoding()
         return getpass.getpass(prompt.encode(encoding, 'replace'))
 

